#include <rt/assert.h>
#include <rt/event.h>
#include <rt/task.h>
#include <rt/trap.h>

static const int n = 10;
static RT_EVENT(event);

static void setter(void)
{
    rt_task_drop_privilege();
    for (int i = 0; i < n; ++i)
    {
        rt_task_sleep(5);
        rt_event_set(&event, 1);
    }
}

static void waiter(void)
{
    rt_task_drop_privilege();
    uint32_t bits;

    for (int i = 0; i < n; ++i)
    {
        bits = rt_event_timedwait(&event, 1, 10);
        rt_assert((bits & 1) != 0, "wait timed out");
    }

    bits = rt_event_timedwait(&event, 1, 10);
    rt_assert((bits & 1) == 0, "wait didn't time out");

    rt_trap();
}

RT_TASK(setter, RT_STACK_MIN, 1);
RT_TASK(waiter, RT_STACK_MIN, 1);
