#pragma once

#include <rt/atomic.h>
#include <rt/cond.h>
#include <rt/mutex.h>

struct rt_event;

uint32_t rt_event_clear(struct rt_event *, uint32_t);

uint32_t rt_event_get(const struct rt_event *);

uint32_t rt_event_set(struct rt_event *, uint32_t);

uint32_t rt_event_wait(struct rt_event *, uint32_t);

uint32_t rt_event_wait_all(struct rt_event *, uint32_t);

uint32_t rt_event_trywait(struct rt_event *, uint32_t);

uint32_t rt_event_trywait_all(struct rt_event *, uint32_t);

uint32_t rt_event_timedwait(struct rt_event *, uint32_t, unsigned long ticks);

uint32_t rt_event_timedwait_all(struct rt_event *, uint32_t,
                                unsigned long ticks);

struct rt_event
{
    rt_atomic_uint32_t bits;
    struct rt_mutex mutex;
    struct rt_cond cond;
};

#define RT_EVENT_INIT(name)                                                    \
    {                                                                          \
        .bits = UINT32_C(0), .mutex = RT_MUTEX_INIT(name.mutex),               \
        .cond = RT_COND_INIT(name.cond),                                       \
    }

#define RT_EVENT(name) struct rt_event name = RT_EVENT_INIT(name)
